// aus: G. Krüger, Handbuch der Java-Programmierung, 5. Aufl., 2007.

import java.io.*;
import java.util.*;

public class ElternKindGraph
{
  public static void main(String[] args)
  {
    //Erzeugen der Familie
    Person opa = new Person("Eugen", null, null);
    Person oma = new Person("Therese", null, null);
    Person vater = new Person("Barny", opa, oma);
    Person mutter = new Person("Wilma", null, null);
    Person kind1 = new Person("Fritzchen", vater, mutter);
    Person kind2 = new Person("Kalli",  vater, mutter);

    //Serialisieren der Familie
    try {
      FileOutputStream fs = new FileOutputStream("familie.ser");
      ObjectOutputStream os = new ObjectOutputStream(fs);
      os.writeObject(kind1);
      os.writeObject(kind2);
      os.close();
    } catch (IOException e) {
      System.err.println(e.toString());
    }

    //Rekonstruieren der Familie
    kind1 = kind2 = null; 
    try {
      FileInputStream fs = new FileInputStream("familie.ser");
      ObjectInputStream is = new ObjectInputStream(fs);
      kind1 = (Person)is.readObject();
      kind2 = (Person)is.readObject();
      //Überprüfen der Objekte
      System.out.println(kind1.getName());
      System.out.println(kind2.getName());
      System.out.println(kind1.getVater().getName());
      System.out.println(kind1.getMutter().getName());
      System.out.println(kind2.getVater().getName());
      System.out.println(kind2.getMutter().getName());
      System.out.println(kind1.getVater().getVater().getName());
      System.out.println(kind1.getVater().getMutter().getName());
      
      //Name des Vaters ändern
      kind1.getVater().setName("Fred") ;
//      kind1.father.name = "Fred";
       
      //Erneutes Überprüfen der Objekte
      System.out.println("---"); 
      System.out.println(kind1.getName());
      System.out.println(kind2.getName());
      System.out.println(kind1.getVater().getName());
      System.out.println(kind1.getMutter().getName());
      System.out.println(kind2.getVater().getName());
      System.out.println(kind2.getMutter().getName());
      System.out.println(kind1.getVater().getVater().getName());
      System.out.println(kind1.getVater().getMutter().getName());

      is.close();
    } catch (ClassNotFoundException e) {
      System.err.println(e.toString());
    } catch (IOException e) {
      System.err.println(e.toString());
    }
  }
}